<?php
/**
-------------------------
COPYRIGHT NOTICES
-------------------------
This file is part of FlexicaCMS.

/**
 * $Id$
 *
 * @author FlexicaCMS team <contact@flexicacms.com>
 * @link http://www.flexicacms.com/
 * @copyright Copyright &copy; 2009-2010 Gia Han Online Solutions Ltd.
 * @license http://www.flexicacms.com/license.html
 */

class FDbWebLogRoute extends CWebLogRoute
{
    private $_startTime = null;
    
    private $times = array();
    
    public function setActive($value) {
        if ($value == true)
            $this->_startTime = microtime(true);
        elseif ($this->_startTime > 0) {
            $this->times[] = array($this->_startTime, microtime(true));
            $this->_startTime = -1;
        }
    }
    
    public function init(){
        $this->categories = 'system.db.CDbCommand';
        $this->formatSQLs();
    }
    
    /**
     * Displays the log messages.
     * @param array $logs list of log messages
     */
    public function processLogs($logs)
    {
        $processedLogs = array();
        foreach ($logs as $log)
            foreach($this->times as $range) 
                if ($log[3] >= $range[0] && $log[3]<= $range[1] 
                    && strpos($log[0],'SHOW COLUMNS')===false
                    && strpos($log[0],'SHOW CREATE')===false){
                    $log[0] = substr($log[0],0,strpos($log[0],"\nin "));
                    $processedLogs[] = $log;
                }
        $this->formatSQLs();
        parent::processLogs($processedLogs);
    }
    
    private function formatSQLs() {
//        $assetPath = Yii::app()->core->AssetPath;
        $assetPath = Yii::app()->assetManager->publish(Yii::getPathOfAlias('ext').'/assets');
        Yii::app()->clientScript->registerScriptFile($assetPath.'/scripts/code.prettify/prettify.js', CClientScript::POS_BEGIN);
        Yii::app()->clientScript->registerCssFile($assetPath.'/scripts/code.prettify/prettify.css');
        $script = <<<EOD
$('.yiiLog td pre').addClass('prettyprint');
prettyPrint();
EOD;
        Yii::app()->clientScript->registerScript('format-logged-queries',$script,CClientScript::POS_READY);
    }
}


/*************** // Log executed SQL queries // ******************/
 
/**
* begin loggin executed SQL query
*/
function dbLogBegin(){
    $dbLogRoute = Yii::app()->log->Routes['dbLog'];
    $dbLogRoute->Active=true;
}

/**
* stop logging executed SQL query
*/
function dbLogEnd(){
    $dbLogRoute = Yii::app()->log->Routes['dbLog'];
    $dbLogRoute->Active=false;
}
?>